=== debian/changelog ===
iotjs (1.0+715-1ubuntu2) impish; urgency=medium

  * Remove alternative build dep on Python

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 07 Jun 2021 11:50:45 +0200

iotjs (1.0+715-1ubuntu1) hirsute; urgency=medium

  * debian/rules: Optimize CMake build for size (-Os/MinSizeRel)
    This is the setting upstream is using and avoids a FTBFS on s390x with
    hardening/fortify enabled.
    Forwarded: https://github.com/jerryscript-project/jerryscript/issues/4431

 -- Lukas Märdian <lukas.maerdian@canonical.com>  Thu, 04 Feb 2021 12:35:41 +0100

iotjs (1.0+715-1) unstable; urgency=medium

  * New upstream snapshot "release_1.0-715-g7fdafb0e" (Closes: #972228)
  * debian/patches: Drop 0003-cmake-Allow-one-to-select-python3-from-env.patch
  * debian/patches: Port patches to current base
  * debian/rules: Update jerryscript flags
  * debian/iotjs-dev.install: Update static lib path
  * debian/copyright: Update removed files
  * debian/source/lintian-overrides: Relax Lintian on test files
  * Maintain under Debian JS Team umbrella

 -- Philippe Coval <rzr@users.sf.net>  Fri, 16 Oct 2020 16:09:46 +0000
