=== debian/control ===
Source: iotjs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Philippe Coval <rzr@users.sf.net>
Section: javascript
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               docbook-to-man,
               python3,
               libcurl4-gnutls-dev | libcurl-ssl-dev | libcurl-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/js-team/iotjs/-/tree/debian/master
Vcs-Git: https://salsa.debian.org/js-team/iotjs.git#debian/master
Homepage: https://iotjs.net
Rules-Requires-Root: no

Package: iotjs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Javascript Framework for Internet of Things
 Inter-operable service platform in the world of IoT,
 based on web technology.
 The target of IoT.js is to run in resource constrained devices
 such as only few kilobytes of RAM available device.

Package: iotjs-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Developer files for Javascript Framework for IoT
 This package ships static library and developments files.
 C Headers are installed into iotjs namespace.
 This is mostly useful to embed iot.js in applications or debugging purposes.
