=== debian/watch ===
version=3
opts="filenamemangle=s%(?:.*?/)?release_(\d[\d.]*)\.tar\.gz%iotjs-$1.tar.gz%" \
   https://github.com/samsung/iotjs/tags \
   (?:.*?/)?release_(\d[\d.]*)\.tar\.gz debian uupdate

#Note: tarball is not shippimng git modules, so better build it using gbp --git-submodules
